unit _Main;

interface

uses
	Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
	StdCtrls, Mask, ExtCtrls;

type
	TMain = class(TForm)
		EditTime: TMaskEdit;
		At: TRadioButton;
		After: TRadioButton;
		Activate: TButton;
		Close: TButton;
		Timer: TTimer;
    Ticker: TTimer;
		procedure CloseClick(Sender: TObject);
		procedure ActivateClick(Sender: TObject);
		procedure AfterAtClick(Sender: TObject);
		procedure TimerTimer(Sender: TObject);
		procedure TickerTimer(Sender: TObject);
	private
		procedure EditTimeNow;
	end;

var
	Main: TMain;

implementation
{$R *.DFM}
						
procedure TMain.CloseClick(Sender: TObject);
begin
	Application.Terminate;
end;

procedure TMain.ActivateClick(Sender: TObject);
var
	x: extended;
begin
	try
		x:= 24*60*60*1000*StrToTime(EditTime.Text) - Ord(At.Checked)*24*60*60*1000*Time;
	except
		on EConvertError do begin EditTimeNow; Exit; end;
	end;     
	if Round(x) <= 0 then Exit;
	Timer.Interval:= Round(x);
	Timer.Enabled:= True;
	if After.Checked then Ticker.Enabled:= True;
	if After.Checked then Application.Title:= 'Budek za ' + EditTime.Text
	else Application.Title:= 'Budek v ' + EditTime.Text;
	Application.Minimize;
end;

procedure TMain.EditTimeNow;
var s: string;
begin
	if At.Checked then s:= TimeToStr(Time + StrToTime(EditTime.Text))
	else s:= TimeToStr(StrToTime(EditTime.Text) - Time);
	if Length(s) < 8 then s:= '0' + s;
	EditTime.Text:= s;
end;

procedure TMain.AfterAtClick(Sender: TObject);
begin
	Ticker.Enabled:= Timer.Enabled and After.Checked;
	EditTimeNow;
end;

procedure TMain.TimerTimer(Sender: TObject);
begin
	Timer.Enabled:= False;
	Ticker.Enabled:= False;
	Application.Title:= 'Budek';
	EditTime.Text:= '  :  :  ';
	MessageBeep(0);
	Application.Restore;
	Application.BringToFront;
end;

procedure TMain.TickerTimer(Sender: TObject);
var
	s: string;
begin
	s:= TimeToStr(StrToTime(EditTime.Text) - 1/(24*60*60));
	if Length(s) < 8 then s:= '0' + s;
	EditTime.Text:= s;
	Application.Title:= 'Budek za ' + s;
end;

end.

